# Sinara 2238 MCX TTL card

[Wiki](https://github.com/sinara-hw/DIO_MCX/wiki)
[Datasheet](https://m-labs.hk/docs/sinara-datasheets/2238.pdf)

# JSON

```json
[
    {
        "type": "dio",
        "board": "DIO_MCX",
        "ports": [0],
        "edge_counter": true, // optional
        "bank_direction_low": "input",
        "bank_direction_high": "output"
    },
    {
        "type": "dio",
        "board": "DIO_MCX",
        "ports": [1],
        "bank_direction_low": "output",
        "bank_direction_high": "output"
    }
]
```

Since MCX TTL has twice as much as BNC/SMA cards, it is treated as two cards - there are 2 ports to be connected
and 2 entries in the JSON.

## Setup

Switch the direction switches (shown on the picture below) according to customer requests.
Remember, that you can only switch directions in groups of four.

![](../img/ttl_mcx.jpg)

## Test

Refer to the [BNC/SMA TTL instructions](bnc_sma_ttl.md) for testing, but chose appropriate connector, 
and respect increased number of channels.